#!/bin/bash
#
# This kio-bashin script allow to KDE Debian users to browse their APT database and installed packages.
#

eval LAST=\${$#}

tmpfile="/tmp/dev_tmp.txt"
indexfile="/tmp/dev_idx.txt"
sections="/tmp/dev_sect.txt"
lock="/tmp/dev_lock.txt"

function lock {
	echo 1 > $lock
}

function unlock {
	rm $lock
}

if [ "$1" == "*mime" ]
	echo "plain/text"
fi

if [ "$1" == "*file" ]
then
	apt-cache show "$LAST"
fi	

if [ "$1" == "*dir" ]
then
	if [ "$2" == "" ]
	then
		echo "*Installed"
		echo "*All packages"
	fi
	if [ "$2" == "Installed" ]
	then
		apt-cache pkgnames|sed "s/^/./;s/$/\n0*plain\/text/"
	fi
	if [ "$2" == "All packages" ]
	then
		if [ "$3" == "" ]
		then
			if [ -e "$lock" ]
			then
				echo
			else
				lock
				ls -1 /var/lib/apt/lists/*|xargs cat 2>/dev/null 1> $tmpfile
				cat $tmpfile |sed -n "s/Section: \(.*\)/\\1/p"|sed "s/\// /g"|sort|uniq > $sections
				cat $tmpfile|sed -n "
					/^Package: /{
					s/^Package: \(.*\)/[package:\\1]/
					h
					:sect
						n
						s/^Section\: \(.*\)/[section:\\1]/
					T sect
					s/\// /g
					H
					:size
						n
						s/^Size\: \(.*\)/[size:\\1]/
						T size
					H
					x
					s/\n//g
					p
				}
				" > $indexfile
				rm $tmpfile
				unlock
				cat $sections|sed "s/^/*/"
			fi
			cat $sections|sed "s/^/*/"
		else
			cat $indexfile|sed -n "s/\[package:\([^\]*\)\]\[section:$3\]\[size:\([^\]*\)\]/.\\1\n\\2*text\/plain/p"
		fi
	fi
fi
